routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('login.login');
})->name('login_index');
//Route::post('Home', 'LoginController@index')->name('home');

//Auth::routes();
Route::post('logeo','Auth\LoginController@login')->name('login');
Route::post('logout','Auth\LoginController@logout')->name('logout');
Route::get('/Home', 'HomeController@index')->name('home');

/* VOLUNTARIOS */
Route::group(['middleware' => ['permission:mod-voluntaios']], function () {
    Route::get('voluntarios', 'VoluntariosController@index')->name('voluntario.index');
    Route::get('voluntario_alta', 'VoluntariosController@create')->name('voluntario.alta');
    Route::post('voluntario_store', 'VoluntariosController@store')->name('voluntario.store');
    Route::post('voluntario_interaccion', 'VoluntariosController@storeInteraccion')->name('interaccion.store');
    Route::get('voluntario_show/{idvoluntario}', 'VoluntariosController@show')->name('voluntario.show');
    Route::get('voluntario_edit/{idvoluntario}', 'VoluntariosController@edit')->name('voluntario.edit');
    Route::put('voluntario_update/{idvoluntario}/up', 'VoluntariosController@update')->name('voluntario.update');
    Route::delete('voluntario_destroy/{idvoluntario}', 'VoluntariosController@destroy')->name('voluntario.destroy');
    Route::get('voluntario_interacciones_imprimir/{id}' ,'VoluntariosController@imprimirInteracciones')->name('btn_imprimir');
    Route::post('voluntario_ajax_dni' ,'VoluntariosController@ajaxValidarDni')->name('ajax_dni');
});

Route::group(['middleware' => ['permission:mod-dirigentes']], function () {
    Route::resource('dirigentes', 'DirigentesController');
});
Route::group(['middleware' => ['permission:mod-miembros']], function () {
    Route::resource('miembros', 'MiembrosController');
});
Route::group(['middleware' => ['permission:mod-roles-permisos']], function () {
    Route::resource('roles-permisos', 'RolesPermisosController');
});
Route::group(['middleware' => ['permission:mod-usuarios']], function () {
    Route::resource('usuarios', 'UsuariosController');
});

Route::get('circuitos', 'CircuitoController@index')->name('circuitos.index');
Route::post('padron_add','CircuitoController@store')->name('padron.store');


/* 
+--------+-----------+----------------------------------------+------------------------+------------------------------------------------------------------+-------------------------------+
| Domain | Method    | URI                                    | Name                   | Action                                                           | Middleware
    |
+--------+-----------+----------------------------------------+------------------------+------------------------------------------------------------------+-------------------------------+
|        | GET|HEAD  | /                                      | login_index            | Closure                                                          | web
    |
|        | GET|HEAD  | Home                                   | home                   | App\Http\Controllers\HomeController@index                        | web
    |
|        |           |                                        |                        |                                                                  | auth
    |
|        | GET|HEAD  | api/user                               |                        | Closure                                                          | api
    |
|        |           |                                        |                        |                                                                  | auth:api
    |
|        | GET|HEAD  | dirigentes                             | dirigentes.index       | App\Http\Controllers\DirigentesController@index                  | web
    |
|        |           |                                        |                        |                                                                  | permission:mod-dirigentes 
    |
|        | POST      | dirigentes                             | dirigentes.store       | App\Http\Controllers\DirigentesController@store                  | web
    |
|        |           |                                        |                        |                                                                  | permission:mod-dirigentes 
    |
|        | GET|HEAD  | dirigentes/create                      | dirigentes.create      | App\Http\Controllers\DirigentesController@create                 | web
    |
|        |           |                                        |                        |                                                                  | permission:mod-dirigentes 
    |
|        | PUT|PATCH | dirigentes/{dirigente}                 | dirigentes.update      | App\Http\Controllers\DirigentesController@update                 | web
    |
|        |           |                                        |                        |                                                                  | permission:mod-dirigentes 
    |
|        | GET|HEAD  | dirigentes/{dirigente}                 | dirigentes.show        | App\Http\Controllers\DirigentesController@show                   | web
    |
|        |           |                                        |                        |                                                                  | permission:mod-dirigentes 
    |
|        | DELETE    | dirigentes/{dirigente}                 | dirigentes.destroy     | App\Http\Controllers\DirigentesController@destroy                | web
    |
|        |           |                                        |                        |                                                                  | permission:mod-dirigentes 
    |
|        | GET|HEAD  | dirigentes/{dirigente}/edit            | dirigentes.edit        | App\Http\Controllers\DirigentesController@edit                   | web
    |
|        |           |                                        |                        |                                                                  | permission:mod-dirigentes 
    |
|        | POST      | logeo                                  | login                  | App\Http\Controllers\Auth\LoginController@login                  | web
    |
|        | POST      | logout                                 | logout                 | App\Http\Controllers\Auth\LoginController@logout                 | web
    |
|        | POST      | miembros                               | miembros.store         | App\Http\Controllers\MiembrosController@store                    | web
    |
|        |           |                                        |                        |                                                                  | permission:mod-miembros   
    |
|        | GET|HEAD  | miembros                               | miembros.index         | App\Http\Controllers\MiembrosController@index                    | web
    |
|        |           |                                        |                        |                                                                  | permission:mod-miembros   
    |
|        | GET|HEAD  | miembros/create                        | miembros.create        | App\Http\Controllers\MiembrosController@create                   | web
    |
|        |           |                                        |                        |                                                                  | permission:mod-miembros   
    |
|        | DELETE    | miembros/{miembro}                     | miembros.destroy       | App\Http\Controllers\MiembrosController@destroy                  | web
    |
|        |           |                                        |                        |                                                                  | permission:mod-miembros   
    |
|        | PUT|PATCH | miembros/{miembro}                     | miembros.update        | App\Http\Controllers\MiembrosController@update                   | web
    |
|        |           |                                        |                        |                                                                  | permission:mod-miembros   
    |
|        | GET|HEAD  | miembros/{miembro}                     | miembros.show          | App\Http\Controllers\MiembrosController@show                     | web
    |
|        |           |                                        |                        |                                                                  | permission:mod-miembros   
    |
|        | GET|HEAD  | miembros/{miembro}/edit                | miembros.edit          | App\Http\Controllers\MiembrosController@edit                     | web
    |
|        |           |                                        |                        |                                                                  | permission:mod-miembros   
    |
|        | GET|HEAD  | roles-permisos                         | roles-permisos.index   | App\Http\Controllers\RolesPermisosController@index               | web
    |
|        |           |                                        |                        |                                                                  | permission:mod-roles-permisos |
|        | POST      | roles-permisos                         | roles-permisos.store   | App\Http\Controllers\RolesPermisosController@store               | web
    |

resources/views/usuarios/create.blade.php
@extends('layout')

@section('title', 'Alta Usuarios')

@section('seccionSaludo')
<h1>Nuevo Usuario</h1>
@endsection

@section('contenido')

    <div class="col-md-12">
        <div class="row">
            <a href="{{route('usuarios.index')}}" class="btn btn-dark float-left" style="margin-bottom: 3%;">Volver</a>
        </div>
{{--         <div class="text-center">
            <h3 class="title">Nuevo usuarios</h3>
        </div> --}}
        <form id="usuarios_store" action="{{ route('usuarios.store') }}" method="POST" enctype="multipart/form-data">
            @csrf
            <div class="row">
                <div class="col-lg-6 col-sm-4">
                    <div class="form-group has-default">
                    <label>Nombre:</label>
                    <input type="text" class="form-control" name="nombre" 
                    value="{{old('nombre')}}">
                    </div>
                    
                    <span class="badge badge-danger">{{ $errors->first('nombre')}}</span>
                </div>
                <div class="col-lg-6 col-sm-4">
                    <div class="form-group has-default">
                    <label>Apellido:</label>
                    <input type="text" class="form-control" name="apellido" 
                    value="{{old('apellido')}}">
                    </div>
                    <span class="badge badge-danger">{{ $errors->first('nombre')}}</span>
                </div>
            </div>
            <div class="row">
                <div class="col-lg-6 col-sm-4">
                    <div class="form-group has-default">
                    <label>DNI:</label>
                    <input type="number" class="form-control" min="1" step="1" name="dni" 
                    value="{{old('dni')}}">
                    </div>
                    <span class="badge badge-danger">{{ $errors->first('dni')}}</span>
                </div>
                <div class="col-lg-6 col-sm-4">
                    <div class="form-group has-default">
                    <label>Correo:</label>
                    <input type="email" class="form-control" name="email" 
                    value="{{old('email')}}">
                    </div>
                    <span class="badge badge-danger">{{ $errors->first('email')}}</span>
                </div>
            </div>
            <div class="row">
                <div class="col-lg-6 col-sm-4">
                    <div class="form-group has-default">
                    <label>Celular:</label>
                    <input type="number" class="form-control" min="1" step="1" name="celular" 
                    value="{{old('celular')}}">
                    </div>
                    <span class="badge badge-danger">{{ $errors->first('celular')}}</span>
                </div>
                <div class="col-lg-6 col-sm-4">
                    <div class="form-group has-default">
                    <label>Telefono:</label>
                    <input type="number" class="form-control" name="telefono">
                    </div>
                    
                </div>
            </div>
            <div class="row">

                <div class="col-lg-6 col-sm-4">
                    <div class="form-group">
                    <label>Departamentos:</label>
                    <select class="form-control"  name="departamento" id="departamentos">
                        <option></option>
                        @foreach($departamentos as $depto)
                            <option value="{{$depto->iddepartamento}}">{{$depto->departamento_nombre}}</option>                        
                        @endforeach
                    </select>
                    </div>
                    <span class="badge badge-danger">{{ $errors->first('departamento')}}</span>
                </div>
                <div class="col-lg-6 col-sm-4">
                    <div class="form-group">
                    <label>Localidades:</label>
                    <input type="hidden" value="{{$localidades}}" id="repoLocalidades">
                    <select class="form-control"  name="localidad" id="localidades">
                        <option></option>
                        @foreach($localidades as $localidad)
                            <option value="{{$localidad->idlocalidad}}">{{$localidad->localidad_nombre}}</option>                        
                        @endforeach
                    </select>
                    </div>
                    <span class="badge badge-danger">{{ $errors->first('localidad')}}</span>
                </div>
                
            </div>
            <div class="row">
                <div class="col-lg-6 col-sm-4">
                    <div class="form-group has-default">
                    <label>Fecha de Nacimiento:</label>
                    <input type="date" class="form-control" name="fecha_nacimiento" 
                    value="{{old('fecha_nacimiento')}}">
                    </div>
                    <span class="badge badge-danger">{{ $errors->first('fecha_nacimiento')}}</span>
                </div>
                <div class="col-lg-6 col-sm-4">
                    <div class="form-group">
                    <label>Circuitos:</label>
                    <input type="hidden" value="{{$circuitos}}" id="repoCircuitos">
                    <select class="form-control"  name="circuitos" id="circuitos">
                        <option></option>
                        @foreach($circuitos as $circuito)
                            <option value="{{$circuito->idcircuito}}">{{$circuito->circuito_nombre}}</option>                        
                        @endforeach
                    </select>
                    </div>
                    <span class="badge badge-danger">{{ $errors->first('circuitos')}}</span>
                </div>
            </div>

                <h5 for="sel1">Direccion:</h5>
            <div class="row">
                <div class="col-lg-6 col-sm-4">
                    <div class="form-group has-default">
                    <label>Calle:</label>
                    <input type="text" class="form-control" name="calle" 
                    value="{{old('calle')}}">
                    </div>
                    <span class="badge badge-danger">{{ $errors->first('calle')}}</span>
                </div>
                <div class="col-lg-6 col-sm-4">
                    <div class="form-group has-default">
                    <label>Número:</label>
                    <input type="number" class="form-control" name="numero" 
                    value="{{old('numero')}}">
                    </div>
                    <span class="badge badge-danger">{{ $errors->first('numero')}}</span>
                </div>
            </div>
            <div class="row">
                <div class="col-lg-6 col-sm-4">
                    <div class="form-group has-default">
                    <label>Piso:</label>
                    <input type="text" class="form-control" name="piso">
                    </div>
                </div>
                <div class="col-lg-6 col-sm-4">
                    <div class="form-group has-default">
                    <label>Departamento:</label>
                    <input type="text" class="form-control" name="dpto" >
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-lg-6 col-sm-4">
                    <div class="form-group has-default">
                    <label>Manzana:</label>
                    <input type="text" class="form-control" name="manzana">
                    </div>
                </div>
                <div class="col-lg-6 col-sm-4">
                    <div class="form-group has-default">
                    <label>Casa:</label>
                    <input type="text" class="form-control" name="casa">
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-lg-6 col-sm-4">
                    <div class="form-group has-default">
                        <label>Contraseña:</label>
                        <input type="password" 
                                class="form-control" 
                                name="password">
                    </div>
                </div>
                <div class="col-lg-6 col-sm-4">
                    <div class="form-group">
                    <label>Roles:</label>
                    <select class="form-control"  name="roles" id="roles">
                        <option></option>
                        @foreach($roles as $rol)
                            <option value="{{$rol->name}}">
                                @if ($rol->id == 2)
                                Coordinador                              
                                @else                                
                                {{ $rol->name}}
                                @endif
                            </option>                        
                        @endforeach
                    </select>
                    </div>
                    <span class="badge badge-danger">{{ $errors->first('roles')}}</span>
                </div> 
            </div>
            <div class="row d-flex justify-content-center" style="margin-bottom: 4%;">
                <div class="d-flex justify-content-around">
                    <img class="img-raised rounded img-fluid" id="Foto" src="" alt="Foto" style="width: 35%;height: 35vh;display:none;">
                    <div class="">
                        <input type="file" class="form-control" id="fotousuario" name="file">
                        <span class="badge badge-danger">{{ $errors->first('file')}}</span>
                    </div>
                </div>
                               
            </div>
            <div>
                <button type="submit" class="btn btn-info d-block" style="width:100%">Guardar</button>
            </div>
        </form>
    </div>

@endsection

@section('script')
<script>

$(document).ready(function(){
    var localidades = JSON.parse( $('#repoLocalidades').val() );
    var circuitos = JSON.parse($('#repoCircuitos').val());
    $('#departamentos').change(function(e){
        var iddpto = $(this).val();
        $('#localidades').html('');
        $('#localidades').append('<option></option>');
        localidades.forEach((elem)=>{
            if(iddpto == elem.departamento_iddepartamento){
                $('#localidades').append('<option value="'+elem.idlocalidad+'">'+elem.localidad_nombre+'</option>');
            }
        });
        $('#circuitos').html('');
    });
    $('#localidades').change(function(e){
        var idlocalidad = $(this).val();
        $('#circuitos').html('');
        $('#circuitos').append('<option></option>');
        circuitos.forEach((elem)=>{
            if(idlocalidad == elem.localidad_idlocalidad){
                $('#circuitos').append('<option value="'+elem.idcircuito+'">'+elem.circuito_nombre+'</option>');
            }
        });
    });
    $("#fotousuario").on("change", function(e) {
        var TmpPath = URL.createObjectURL(e.target.files[0]);
        // Mostramos la ruta temporal
        $('#Foto').attr('src', TmpPath);
        $('#Foto').show();
    });
});
</script>
@endsection

resources/views/usuarios/index.blade.php
@extends('layout')
@php
    use Spatie\Permission\Models\Role;
    use Spatie\Permission\Models\Permission;
@endphp

@section('title', 'usuarios')

@section('seccionSaludo')
<h1>Listado de usuarios</h1>
{{-- <h3 class="title text-center">---</h3> --}}
@endsection

@section('contenido')

    <div class="col-md-12">
        <div class="row">
            <a href="{{route('usuarios.create')}}"; class="btn btn-success" style="margin-left: 89%;">Nuevo</a>
        </div>
        <div class="table-responsive" id="seccionTabla">
            <table class="table table-striped table-dark" id="tableUsers">
                <thead class="thead-dark">
                <tr>
                    <th>Nombre y Apellido</th>
                    <th>Celular</th>
                    <th>Email</th>
                    <th>Rol</th>
                    <th>CRUD</th>
                </tr>
                </thead>
                <tbody>
                    @foreach($users as $user)  
                        <tr>
                            <td>{{ $user->apellido .','.$user->nombre}}</td>
                            <td>{{ $user->celular}}</td>
                            <td>{{ $user->email}}</td>                              
                            <td>
                                @if ($user->getRoleNames()[0] == 'Miembro')
                                Coordinador                              
                                @else                                
                                {{ $user->getRoleNames()[0]}}
                                @endif                                
                            </td>
                            <td>
                                <a href="javascript:;" class="showuser" id="show_{{ $user->id}}"><i class="far fa-eye fa-2x"></i></a>
                                <a href="{{route('usuarios.edit',$user->id)}}" class="edituser" id="edit_{{ $user->id}}"><i class="far fa-edit fa-2x"></i></a>
                                
                                <a href="javascript:;"
                                    onclick="eliminarUser({{ $user->id}});"><i class="fas fa-times fa-2x"></i></a>
                                <form id="delete-form_{{ $user->id}}" action="{{ route('usuarios.destroy',$user->id) }}" method="POST" style="display: none;">
                                    {{ csrf_field() }}
                                    {{ method_field('DELETE') }}
                                </form>                                
                            </td>
                        </tr>
                    @endforeach
                </tbody>
            </table>

        </div>

        <div class="text-center" id="seccionDatos" style="display:none;">
            <h3 id="nombreUsuario"></h3>
            <div class="row">
                @include('view_repositorios.card_info', array('cardHeader'=>'USUARIO'))                
            </div>
            <button class="btn btn-primary btn-sm pull-left" id="volverList">Volver al listado<div class="ripple-container"></div></button>
        </div>
    </div>


@endsection

@section('script')
<script>

$(document).ready(function() {
    setTimeout(function() {
      $('#message').fadeOut('fast');
    }, 3500);

    $('#tableUsers').DataTable({
        "language": {
            "url": "//cdn.datatables.net/plug-ins/1.10.21/i18n/Spanish.json"
        },
        // pageLength : 5,
        lengthMenu: [[10, 20, -1], [10, 20, 'Todos']]
        
    });
});
function eliminarUser(idUser){
    if(confirm('Esta acción no podrá deshacerse. ¿Continuar?')){

        document.getElementById('delete-form_'+idUser).submit();
    }
}
$(document).on('click','.showuser',function(){
    let id = $(this).prop('id').split('_')[1];
    let ruta  =  "{{ URL::to('usuarios/') }}"+"/"+id;
    $.ajax({
      type: 'GET',
      url: ruta,
      //data: form.serialize(),
      beforeSend: function(){ },
      error: function(jqxhr, textStatus, error){
          console.log(error);
          /* let a = ( jqxhr.responseJSON.errors.palabra != null )?jqxhr.responseJSON.errors.palabra:'';
            $('.palabra').html(a);

          console.log(jqxhr);
          let id = '#ajaxError';
          $(id).html('ocurio un error vuelva a intentar');
          mjsAlert(id);*/
      },
      success: function(respuesta){
        
        if (respuesta.status ) {
            $('#nombreUsuario').html(respuesta.usuario.apellido+', '+respuesta.usuario.nombre);
            $('#foto').attr( "src" ,respuesta.usuario.foto);
            $('#direccion').html(respuesta.direccion.calle+' '+respuesta.direccion.numero);
            $('#telefono').html(respuesta.usuario.telefono);
            $('#celular').html(respuesta.usuario.celular);
            $('#correo').html(respuesta.usuario.email);
            $('#localidad').html(respuesta.localidad.localidad_nombre);
            $('#departamento').html(respuesta.departamento.departamento_nombre);
            $('#seccionTabla').hide('slow');
            $('#seccionDatos').show('slow');
        }
      },
      dataType: 'json',
      async:true
    });

});

$(document).on('click','#volverList',function(){
    $('#seccionDatos').hide('slow');
    $('#seccionTabla').show('slow');
});
</script>
@endsection